`timescale 1ns / 1ps
module spi_if(
    input         clk,
    input         rst,
    output        cs,
    output        sck,
    input         miso,
    output [12:0] dout
);


// Ciklus idzt szmll, ~330 ms
reg [24:0] cntr = 0;
always @ (posedge clk)
	cntr <= cntr + 1;

// SPI rajel
assign sck = cntr[3];


// SPI rajel felfut l
wire sck_rise;
assign sck_rise = (cntr[3:0]==3'b0111);

// SPI CS regiszter
reg cs_reg;
always @ (posedge clk)
begin
	if (rst)
      cs_reg <= 1;
   else if (cntr==15)
		cs_reg <= 0;
	else if (cntr==16*16+15)
		cs_reg <= 1;
end
assign cs = cs_reg;

// Adat shift regiszter
reg [15:0] shr;
always @ (posedge clk)
if (cs_reg==0 & sck_rise==1)
	shr <= {shr[14:0], miso};

// Kimeneti regiszter, mindig rvnyes adatot tartalmaz	
reg [12:0] temp_reg;
always @ (posedge clk)
if (cs_reg==1)
	temp_reg <= shr[15:3];

	
assign dout = temp_reg;

endmodule
